include (jslib_dirutils);
include (jslib_prefs);

function MozImagePrefs() 
{
  this.prefs = new Prefs();
  this.load();
}

MozImagePrefs.prototype = {

load : 
  function () {
    this.homeDir = this.prefs.getChar("mozimage.home_directory");
    this.autoSize = this.prefs.getBool("mozimage.autosize");
    this.slideshow = this.prefs.getBool("mozimage.slideshow");
    this.delay = this.prefs.getInt("mozimage.delay");
    this.zoom = this.prefs.getChar("mozimage.zoom");
    this.listCollapsed = false;
    
    this.editorName1 = this.prefs.getChar("mozimage.editorname_1");
    this.editorPath1 = this.prefs.getChar("mozimage.editorpath_1");
    this.editorName2 = this.prefs.getChar("mozimage.editorname_2");
    this.editorPath2 = this.prefs.getChar("mozimage.editorpath_2");
    this.editorName3 = this.prefs.getChar("mozimage.editorname_3");
    this.editorPath3 = this.prefs.getChar("mozimage.editorpath_3");
    this.editorName4 = this.prefs.getChar("mozimage.editorname_4");
    this.editorPath4 = this.prefs.getChar("mozimage.editorpath_4");
    
    var extListStr = this.prefs.getChar("mozimage.extlist");
    if (extListStr == "")
      this.extList = new Array("jpg", "jpeg", "gif", "bmp", "png");
    else
      this.parseExtStr(extListStr);
      
    
    if (this.delay <= 0)
      this.delay = 2000;
    if (this.zoom <= 1)
      this.zoom = 1.5;
   
    if (this.homeDir == "")
    {
      var dirUtils = new DirUtils();
      this.homeDir = dirUtils.getCurProcDir();
    }
  },
  
parseExtStr :
  function (extListStr) {

    var ext = "";
    this.extList = new Array();

    for(var i = 0 ; i < extListStr.length ; i++)
    {
      if (extListStr[i] == ",")
      {
        this.extList.push(ext);
        ext = "";
      }
      else
        ext = ext + extListStr[i];
    }
    if (ext != "")
      this.extList.push(ext);
  },
  
save : 
  function () {
    this.prefs.setChar("mozimage.extlist", this.extList.toString()); 
    this.prefs.setChar("mozimage.home_directory", this.homeDir); 
    this.prefs.setBool("mozimage.autosize", this.autoSize); 
    this.prefs.setBool("mozimage.slideshow", this.slideshow); 
    this.prefs.setInt("mozimage.delay", this.delay); 
    this.prefs.setChar("mozimage.zoom", this.zoom); 

    this.prefs.setChar("mozimage.editorname_1", this.editorName1); 
    this.prefs.setChar("mozimage.editorpath_1", this.editorPath1); 
    this.prefs.setChar("mozimage.editorname_2", this.editorName2); 
    this.prefs.setChar("mozimage.editorpath_2", this.editorPath2); 
    this.prefs.setChar("mozimage.editorname_3", this.editorName3); 
    this.prefs.setChar("mozimage.editorpath_3", this.editorPath3); 
    this.prefs.setChar("mozimage.editorname_4", this.editorName4); 
    this.prefs.setChar("mozimage.editorpath_4", this.editorPath4); 
  },

getHomeDir : 
  function () { return(this.homeDir); },

setHomeDir : 
  function (aValue) { this.homeDir = aValue; },

getListCollapsed : 
  function () { return(this.listCollapsed); },

setListCollapsed : 
  function (aValue) { this.listCollapsed = Boolean(aValue); },

getExtList : 
  function () {
   return(this.extList); 
  },

setExtList : 
  function (aValue) { this.extList = aValue; },

getAutoSize : 
  function () { return(Boolean(this.autoSize)); },

setAutoSize : 
  function (aValue) { this.autoSize = Boolean(aValue); },

getSlideshow : 
  function () { return(Boolean(this.slideshow)); },

setSlideshow : 
  function (aValue) { this.slideshow = Boolean(aValue); },

getDelay : 
  function () { return(Number(this.delay)); },

setDelay : 
  function (aValue) { this.delay = Number(aValue); },
  
getZoom : 
  function () { return(Number(this.zoom)); },

setZoom : 
  function (aValue) { this.zoom = Number(aValue); },

getEditorsName:
  function () { return(new Array(this.editorName1, this.editorName2, this.editorName3, this.editorName4)); },
  
setEditorsName:
  function (aValue) { 
    this.editorName1 = aValue[0];
    this.editorName2 = aValue[1];
    this.editorName3 = aValue[2];
    this.editorName4 = aValue[3];
  },

getEditorsPath:
  function () { return(new Array(this.editorPath1, this.editorPath2, this.editorPath3, this.editorPath4)); },
  
setEditorsPath:
  function (aValue) { 
    this.editorPath1 = aValue[0];
    this.editorPath2 = aValue[1];
    this.editorPath3 = aValue[2];
    this.editorPath4 = aValue[3];
  },

toggleExt :
  function (aExt) {
    var index = -1;
    for(var i = 0 ; i < this.extList.length ; i++)
    {
      if (this.extList[i] == aExt)
        index = i;
    }
    if (index != -1)
      this.extList.splice(index, 1);
    else
      this.extList.push(aExt);
  }

} // END CLASS

/*
**
** Predefined instance of the preferences class
** do not use any other instances
**
*/

var prefs = new MozImagePrefs();

/*
**
** Prefs window event handlers
**
*/

function prefs_load()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  prefs.load();
  var extList = prefs.getExtList();

  homedir.value = prefs.getHomeDir();
  delay.value = prefs.getDelay() / 1000;
  zoom.value = prefs.getZoom();
  var editorsName = prefs.getEditorsName();
  var editorsPath = prefs.getEditorsPath();
  
  for(var i = 0 ; i < extList.length ; i++)
  {
    var checkbox = document.getElementById(extList[i] + "-check");
    checkbox.checked = true;
  }
  for(var i = 1 ; i <= 4 ; i++)
  {
    var edit = document.getElementById("editorname" + i + "-text");
    edit.value = editorsName[i-1];
    var edit = document.getElementById("editorpath" + i + "-text");
    edit.value = editorsPath[i-1];
  }
}

function prefs_close()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  var editorsName = new Array();
  var editorsPath = new Array();
  prefs.setHomeDir(homedir.value);
  prefs.setDelay(delay.value * 1000);
  prefs.setZoom(zoom.value);

  for(var i = 1 ; i <= 4 ; i++)
  {
    var edit = document.getElementById("editorname" + i + "-text");
    editorsName[i-1] = edit.value;
    var edit = document.getElementById("editorpath" + i + "-text");
    editorsPath[i-1] = edit.value;
  }
  prefs.setEditorsName(editorsName);
  prefs.setEditorsPath(editorsPath);

  prefs.save();
}

